"use strict";
/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttestTokenHandlerInstance = exports.AttestTokenHandler = void 0;
const web3_1 = require("@alephium/web3");
const AttestTokenHandler_ral_json_1 = __importDefault(require("../token_bridge/AttestTokenHandler.ral.json"));
class Factory extends web3_1.ContractFactory {
    constructor() {
        super(...arguments);
        this.consts = {
            Path: {
                AttestTokenHandler: "00",
                TokenBridgeForChain: "01",
                TokenPool: "02",
            },
            ErrorCodes: {
                InvalidEmitChainId: BigInt(0),
                InvalidEmitAddress: BigInt(1),
                InvalidMessageSize: BigInt(2),
                InvalidSequence: BigInt(3),
                InvalidModule: BigInt(4),
                InvalidActionId: BigInt(5),
                InvalidVersion: BigInt(6),
                InvalidGuardianSetIndex: BigInt(7),
                InvalidGuardianSetSize: BigInt(8),
                InvalidSignatureSize: BigInt(9),
                InvalidSignatureGuardianIndex: BigInt(10),
                InvalidSignature: BigInt(11),
                GuardianSetExpired: BigInt(12),
                InvalidTargetChainId: BigInt(13),
                ContractStateMismatch: BigInt(14),
                InvalidRegisterChainMessage: BigInt(15),
                InvalidTokenId: BigInt(16),
                InvalidNonceSize: BigInt(17),
                TokenNotExist: BigInt(18),
                InvalidTransferTargetChain: BigInt(19),
                InvalidDestroyUnexecutedSequenceMessage: BigInt(20),
                InvalidCaller: BigInt(21),
                ArbiterFeeLessThanAmount: BigInt(22),
                InvalidAttestTokenMessage: BigInt(23),
                InvalidPayloadId: BigInt(24),
                InvalidTransferMessage: BigInt(25),
                ExpectRemoteToken: BigInt(26),
                InvalidConsistencyLevel: BigInt(27),
                InvalidUpdateRefundAddressMessage: BigInt(28),
                TransferAmountLessThanMessageFee: BigInt(29),
                InvalidAttestTokenArg: BigInt(30),
                InvalidAttestTokenHandler: BigInt(31),
                NotSupported: BigInt(32),
            },
            PayloadId: { Transfer: "01", AttestToken: "02" },
        };
        this.tests = {
            parseAttestToken: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "parseAttestToken", params);
            }),
            createLocalTokenPool: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "createLocalTokenPool", params);
            }),
            createRemoteTokenPool: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "createRemoteTokenPool", params);
            }),
            updateRemoteTokenPool: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "updateRemoteTokenPool", params);
            }),
            removeTrailingZeros: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "removeTrailingZeros", params);
            }),
        };
    }
    at(address) {
        return new AttestTokenHandlerInstance(address);
    }
}
// Use this object to test and deploy the contract
exports.AttestTokenHandler = new Factory(web3_1.Contract.fromJson(AttestTokenHandler_ral_json_1.default, "", "a8d5b3de6a6267d4a12eb793dc90832b0b0e5b84f54c5458d0fedfe73dc0871c"));
// Use this class to interact with the blockchain
class AttestTokenHandlerInstance extends web3_1.ContractInstance {
    constructor(address) {
        super(address);
    }
    fetchState() {
        return __awaiter(this, void 0, void 0, function* () {
            return web3_1.fetchContractState(exports.AttestTokenHandler, this);
        });
    }
}
exports.AttestTokenHandlerInstance = AttestTokenHandlerInstance;
