import { Address, ContractState, TestContractResult, HexString, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace BridgeRewardRouterTypes {
    type State = Omit<ContractState<any>, "fields">;
}
declare class Factory extends ContractFactory<BridgeRewardRouterInstance, {}> {
    at(address: string): BridgeRewardRouterInstance;
    tests: {
        completeTransfer: (params: Omit<TestContractParams<never, {
            tokenBridgeForChain: HexString;
            vaa: HexString;
            caller: Address;
        }>, "initialFields">) => Promise<TestContractResult<null>>;
        addRewards: (params: Omit<TestContractParams<never, {
            caller: Address;
            amount: bigint;
        }>, "initialFields">) => Promise<TestContractResult<null>>;
    };
}
export declare const BridgeRewardRouter: Factory;
export declare class BridgeRewardRouterInstance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<BridgeRewardRouterTypes.State>;
}
export {};
