import { Address, ContractState, TestContractResult, HexString, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace GovernanceV1Types {
    type Fields = {
        chainId: bigint;
        governanceChainId: bigint;
        governanceEmitterAddress: HexString;
        tokenBridgeFactory: HexString;
        receivedSequence: bigint;
        messageFee: bigint;
        guardianSets: [HexString, HexString];
        guardianSetIndexes: [bigint, bigint];
        previousGuardianSetExpirationTimeMS: bigint;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<GovernanceV1Instance, GovernanceV1Types.Fields> {
    at(address: string): GovernanceV1Instance;
    tests: {
        foo: (params: Omit<TestContractParams<GovernanceV1Types.Fields, never>, "testArgs">) => Promise<TestContractResult<null>>;
    };
}
export declare const GovernanceV1: Factory;
export declare class GovernanceV1Instance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<GovernanceV1Types.State>;
}
export {};
