"use strict";
/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalTokenPoolInstance = exports.LocalTokenPool = void 0;
const web3_1 = require("@alephium/web3");
const LocalTokenPool_ral_json_1 = __importDefault(require("../token_bridge/LocalTokenPool.ral.json"));
const contracts_1 = require("./contracts");
class Factory extends web3_1.ContractFactory {
    constructor() {
        super(...arguments);
        this.consts = {
            Path: {
                AttestTokenHandler: "00",
                TokenBridgeForChain: "01",
                TokenPool: "02",
            },
            ErrorCodes: {
                InvalidEmitChainId: BigInt(0),
                InvalidEmitAddress: BigInt(1),
                InvalidMessageSize: BigInt(2),
                InvalidSequence: BigInt(3),
                InvalidModule: BigInt(4),
                InvalidActionId: BigInt(5),
                InvalidVersion: BigInt(6),
                InvalidGuardianSetIndex: BigInt(7),
                InvalidGuardianSetSize: BigInt(8),
                InvalidSignatureSize: BigInt(9),
                InvalidSignatureGuardianIndex: BigInt(10),
                InvalidSignature: BigInt(11),
                GuardianSetExpired: BigInt(12),
                InvalidTargetChainId: BigInt(13),
                ContractStateMismatch: BigInt(14),
                InvalidRegisterChainMessage: BigInt(15),
                InvalidTokenId: BigInt(16),
                InvalidNonceSize: BigInt(17),
                TokenNotExist: BigInt(18),
                InvalidTransferTargetChain: BigInt(19),
                InvalidDestroyUnexecutedSequenceMessage: BigInt(20),
                InvalidCaller: BigInt(21),
                ArbiterFeeLessThanAmount: BigInt(22),
                InvalidAttestTokenMessage: BigInt(23),
                InvalidPayloadId: BigInt(24),
                InvalidTransferMessage: BigInt(25),
                ExpectRemoteToken: BigInt(26),
                InvalidConsistencyLevel: BigInt(27),
                InvalidUpdateRefundAddressMessage: BigInt(28),
                TransferAmountLessThanMessageFee: BigInt(29),
                InvalidAttestTokenArg: BigInt(30),
                InvalidAttestTokenHandler: BigInt(31),
                NotSupported: BigInt(32),
            },
            PayloadId: { Transfer: "01", AttestToken: "02" },
        };
        this.tests = {
            getSymbol: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "getSymbol", params);
            }),
            getName: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "getName", params);
            }),
            getDecimals: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "getDecimals", params);
            }),
            getTotalSupply: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "getTotalSupply", params);
            }),
            completeTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "completeTransfer", params);
            }),
            prepareTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "prepareTransfer", params);
            }),
            prepareCompleteTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "prepareCompleteTransfer", params);
            }),
            normalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "normalizeAmount", params);
            }),
            deNormalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "deNormalizeAmount", params);
            }),
            transfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "transfer", params);
            }),
        };
    }
    at(address) {
        return new LocalTokenPoolInstance(address);
    }
}
// Use this object to test and deploy the contract
exports.LocalTokenPool = new Factory(web3_1.Contract.fromJson(LocalTokenPool_ral_json_1.default, "", "6330d3736eef41d3bc9c5026d0608def44267cc00ed8d8be0620d01f4627f035"));
// Use this class to interact with the blockchain
class LocalTokenPoolInstance extends web3_1.ContractInstance {
    constructor(address) {
        super(address);
        this.methods = {
            getSymbol: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "getSymbol", params === undefined ? {} : params, contracts_1.getContractByCodeHash);
            }),
            getName: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "getName", params === undefined ? {} : params, contracts_1.getContractByCodeHash);
            }),
            getDecimals: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "getDecimals", params === undefined ? {} : params, contracts_1.getContractByCodeHash);
            }),
            getTotalSupply: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "getTotalSupply", params === undefined ? {} : params, contracts_1.getContractByCodeHash);
            }),
            normalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "normalizeAmount", params, contracts_1.getContractByCodeHash);
            }),
            deNormalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "deNormalizeAmount", params, contracts_1.getContractByCodeHash);
            }),
            transfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.LocalTokenPool, this, "transfer", params, contracts_1.getContractByCodeHash);
            }),
        };
    }
    fetchState() {
        return __awaiter(this, void 0, void 0, function* () {
            return web3_1.fetchContractState(exports.LocalTokenPool, this);
        });
    }
    multicall(calls) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield web3_1.multicallMethods(exports.LocalTokenPool, this, calls, contracts_1.getContractByCodeHash));
        });
    }
}
exports.LocalTokenPoolInstance = LocalTokenPoolInstance;
