"use strict";
/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenBridgeForChainInstance = exports.TokenBridgeForChain = void 0;
const web3_1 = require("@alephium/web3");
const TokenBridgeForChain_ral_json_1 = __importDefault(require("../token_bridge/TokenBridgeForChain.ral.json"));
const contracts_1 = require("./contracts");
class Factory extends web3_1.ContractFactory {
    constructor() {
        super(...arguments);
        this.consts = {
            Path: {
                AttestTokenHandler: "00",
                TokenBridgeForChain: "01",
                TokenPool: "02",
            },
            ErrorCodes: {
                InvalidEmitChainId: BigInt(0),
                InvalidEmitAddress: BigInt(1),
                InvalidMessageSize: BigInt(2),
                InvalidSequence: BigInt(3),
                InvalidModule: BigInt(4),
                InvalidActionId: BigInt(5),
                InvalidVersion: BigInt(6),
                InvalidGuardianSetIndex: BigInt(7),
                InvalidGuardianSetSize: BigInt(8),
                InvalidSignatureSize: BigInt(9),
                InvalidSignatureGuardianIndex: BigInt(10),
                InvalidSignature: BigInt(11),
                GuardianSetExpired: BigInt(12),
                InvalidTargetChainId: BigInt(13),
                ContractStateMismatch: BigInt(14),
                InvalidRegisterChainMessage: BigInt(15),
                InvalidTokenId: BigInt(16),
                InvalidNonceSize: BigInt(17),
                TokenNotExist: BigInt(18),
                InvalidTransferTargetChain: BigInt(19),
                InvalidDestroyUnexecutedSequenceMessage: BigInt(20),
                InvalidCaller: BigInt(21),
                ArbiterFeeLessThanAmount: BigInt(22),
                InvalidAttestTokenMessage: BigInt(23),
                InvalidPayloadId: BigInt(24),
                InvalidTransferMessage: BigInt(25),
                ExpectRemoteToken: BigInt(26),
                InvalidConsistencyLevel: BigInt(27),
                InvalidUpdateRefundAddressMessage: BigInt(28),
                TransferAmountLessThanMessageFee: BigInt(29),
                InvalidAttestTokenArg: BigInt(30),
                InvalidAttestTokenHandler: BigInt(31),
                NotSupported: BigInt(32),
            },
            PayloadId: { Transfer: "01", AttestToken: "02" },
        };
        this.tests = {
            setExecuted: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "setExecuted", params);
            }),
            compact: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "compact", params);
            }),
            checkSequenceInSubContract: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "checkSequenceInSubContract", params);
            }),
            checkSequence: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "checkSequence", params);
            }),
            nextSendSequence: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "nextSendSequence", params);
            }),
            checkCompleteTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "checkCompleteTransfer", params);
            }),
            parseCompleteTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "parseCompleteTransfer", params);
            }),
            completeTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "completeTransfer", params);
            }),
            destroyUnexecutedSequenceContracts: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "destroyUnexecutedSequenceContracts", params);
            }),
            deposit: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "deposit", params);
            }),
            withdraw: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.testMethod(this, "withdraw", params);
            }),
        };
    }
    at(address) {
        return new TokenBridgeForChainInstance(address);
    }
}
// Use this object to test and deploy the contract
exports.TokenBridgeForChain = new Factory(web3_1.Contract.fromJson(TokenBridgeForChain_ral_json_1.default, "", "58443a1005d6791f07d0701f4ef91ec367777ab67be27990a6b8fcb7c84e7240"));
// Use this class to interact with the blockchain
class TokenBridgeForChainInstance extends web3_1.ContractInstance {
    constructor(address) {
        super(address);
        this.methods = {
            nextSendSequence: (params) => __awaiter(this, void 0, void 0, function* () {
                return web3_1.callMethod(exports.TokenBridgeForChain, this, "nextSendSequence", params === undefined ? {} : params, contracts_1.getContractByCodeHash);
            }),
        };
    }
    fetchState() {
        return __awaiter(this, void 0, void 0, function* () {
            return web3_1.fetchContractState(exports.TokenBridgeForChain, this);
        });
    }
    multicall(calls) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield web3_1.multicallMethods(exports.TokenBridgeForChain, this, calls, contracts_1.getContractByCodeHash));
        });
    }
}
exports.TokenBridgeForChainInstance = TokenBridgeForChainInstance;
