import { RunScriptResult, DeployContractExecutionResult } from "@alephium/cli";
import { NetworkId } from "@alephium/web3";
import { LocalTokenPoolInstance, RemoteTokenPoolInstance, TokenBridgeForChainInstance, AttestTokenHandlerInstance, UnexecutedSequenceInstance, TokenBridgeFactoryInstance, GovernanceInstance, TokenBridgeInstance, BridgeRewardRouterInstance, TestTokenInstance } from ".";
export declare type Deployments = {
    deployerAddress: string;
    contracts: {
        LocalTokenPool: DeployContractExecutionResult<LocalTokenPoolInstance>;
        RemoteTokenPool: DeployContractExecutionResult<RemoteTokenPoolInstance>;
        TokenBridgeForChain: DeployContractExecutionResult<TokenBridgeForChainInstance>;
        AttestTokenHandler: DeployContractExecutionResult<AttestTokenHandlerInstance>;
        UnexecutedSequence: DeployContractExecutionResult<UnexecutedSequenceInstance>;
        TokenBridgeFactory: DeployContractExecutionResult<TokenBridgeFactoryInstance>;
        Governance: DeployContractExecutionResult<GovernanceInstance>;
        TokenBridge: DeployContractExecutionResult<TokenBridgeInstance>;
        BridgeRewardRouter: DeployContractExecutionResult<BridgeRewardRouterInstance>;
        TestToken?: DeployContractExecutionResult<TestTokenInstance>;
    };
    scripts: {
        CreateLocalAttestTokenHandler: RunScriptResult;
        GetToken?: RunScriptResult;
    };
};
export declare function loadDeployments(networkId: NetworkId, deployerAddress?: string): Deployments;
