import { Address, ExecutableScript, HexString } from "@alephium/web3";
export declare const SetMessageFee: ExecutableScript<{
    governance: HexString;
    vaa: HexString;
}>;
export declare const TransferFee: ExecutableScript<{
    governance: HexString;
    vaa: HexString;
}>;
export declare const UpdateGuardianSet: ExecutableScript<{
    governance: HexString;
    vaa: HexString;
}>;
export declare const UpdateGovernanceContract: ExecutableScript<{
    governance: HexString;
    vaa: HexString;
}>;
export declare const GetToken: ExecutableScript<{
    sender: Address;
    token: HexString;
    amount: bigint;
    factor: bigint;
}>;
export declare const AddRewards: ExecutableScript<{
    bridgeRewardRouter: HexString;
    amount: bigint;
}>;
export declare const AttestToken: ExecutableScript<{
    payer: Address;
    tokenBridge: HexString;
    localTokenId: HexString;
    decimals: bigint;
    symbol: HexString;
    name: HexString;
    nonce: HexString;
    consistencyLevel: bigint;
}>;
export declare const CompleteTransfer: ExecutableScript<{
    tokenBridgeForChain: HexString;
    vaa: HexString;
}>;
export declare const CompleteTransferWithReward: ExecutableScript<{
    bridgeRewardRouter: HexString;
    tokenBridgeForChain: HexString;
    vaa: HexString;
}>;
export declare const CreateLocalAttestTokenHandler: ExecutableScript<{
    tokenBridge: HexString;
    payer: Address;
    alphAmount: bigint;
}>;
export declare const CreateLocalTokenPool: ExecutableScript<{
    payer: Address;
    attestTokenHandler: HexString;
    localTokenId: HexString;
    vaa: HexString;
    alphAmount: bigint;
}>;
export declare const CreateRemoteTokenPool: ExecutableScript<{
    payer: Address;
    attestTokenHandler: HexString;
    vaa: HexString;
    alphAmount: bigint;
}>;
export declare const Deposit: ExecutableScript<{
    tokenBridgeForChain: HexString;
    payer: Address;
    amount: bigint;
}>;
export declare const DestroyUnexecutedSequenceContracts: ExecutableScript<{
    tokenBridge: HexString;
    vaa: HexString;
}>;
export declare const RegisterChain: ExecutableScript<{
    payer: Address;
    tokenBridge: HexString;
    vaa: HexString;
    alphAmount: bigint;
}>;
export declare const TransferLocal: ExecutableScript<{
    tokenBridge: HexString;
    fromAddress: Address;
    localTokenId: HexString;
    alphChainId: bigint;
    toChainId: bigint;
    toAddress: HexString;
    tokenAmount: bigint;
    arbiterFee: bigint;
    nonce: HexString;
    consistencyLevel: bigint;
}>;
export declare const TransferRemote: ExecutableScript<{
    tokenBridge: HexString;
    fromAddress: Address;
    tokenPoolId: HexString;
    remoteTokenId: HexString;
    tokenChainId: bigint;
    toChainId: bigint;
    toAddress: HexString;
    tokenAmount: bigint;
    arbiterFee: bigint;
    nonce: HexString;
    consistencyLevel: bigint;
}>;
export declare const UpdateMinimalConsistencyLevel: ExecutableScript<{
    tokenBridge: HexString;
    vaa: HexString;
}>;
export declare const UpdateRefundAddress: ExecutableScript<{
    tokenBridge: HexString;
    vaa: HexString;
}>;
export declare const UpdateRemoteTokenPool: ExecutableScript<{
    attestTokenHandler: HexString;
    vaa: HexString;
}>;
export declare const UpgradeTokenBridgeContract: ExecutableScript<{
    tokenBridge: HexString;
    vaa: HexString;
}>;
