"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSignedVAA = void 0;
const consts_1 = require("../utils/consts");
const publicrpc_1 = require("../proto/publicrpc/v1/publicrpc");
function getSignedVAA(host, emitterChain, emitterAddress, targetChain, sequence, extraGrpcOpts = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const rpc = new publicrpc_1.GrpcWebImpl(host, extraGrpcOpts);
        const api = new publicrpc_1.PublicRPCServiceClientImpl(rpc);
        return yield api.GetSignedVAA({
            messageId: {
                emitterChain: consts_1.coalesceChainId(emitterChain),
                emitterAddress,
                targetChain: consts_1.coalesceChainId(targetChain),
                sequence,
            },
        });
    });
}
exports.getSignedVAA = getSignedVAA;
