"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.importTokenWasm = exports.importNftWasm = exports.importMigrationWasm = exports.importCoreWasm = exports.setDefaultWasm = void 0;
const coreWasms = {
    bundler: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./core/bridge"))); }),
    node: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./core-node/bridge"))); }),
};
const migrationWasms = {
    bundler: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./migration/wormhole_migration"))); }),
    node: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./migration-node/wormhole_migration"))); }),
};
const nftWasms = {
    bundler: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./nft/nft_bridge"))); }),
    node: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./nft-node/nft_bridge"))); }),
};
const tokenWasms = {
    bundler: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./token/token_bridge"))); }),
    node: () => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.resolve().then(() => __importStar(require("./token-node/token_bridge"))); }),
};
let importDefaultCoreWasm = coreWasms.bundler;
let importDefaultMigrationWasm = migrationWasms.bundler;
let importDefaultNftWasm = nftWasms.bundler;
let importDefaultTokenWasm = tokenWasms.bundler;
function setDefaultWasm(type) {
    importDefaultCoreWasm = coreWasms[type];
    importDefaultMigrationWasm = migrationWasms[type];
    importDefaultNftWasm = nftWasms[type];
    importDefaultTokenWasm = tokenWasms[type];
}
exports.setDefaultWasm = setDefaultWasm;
function importCoreWasm() {
    return __awaiter(this, void 0, void 0, function* () {
        return yield importDefaultCoreWasm();
    });
}
exports.importCoreWasm = importCoreWasm;
function importMigrationWasm() {
    return __awaiter(this, void 0, void 0, function* () {
        return yield importDefaultMigrationWasm();
    });
}
exports.importMigrationWasm = importMigrationWasm;
function importNftWasm() {
    return __awaiter(this, void 0, void 0, function* () {
        return yield importDefaultNftWasm();
    });
}
exports.importNftWasm = importNftWasm;
function importTokenWasm() {
    return __awaiter(this, void 0, void 0, function* () {
        return yield importDefaultTokenWasm();
    });
}
exports.importTokenWasm = importTokenWasm;
