import { ExecuteScriptResult, node, NodeProvider, SignerProvider } from "@alephium/web3";
import { ChainId } from "../utils";
import { TokenInfo } from "@alephium/token-list";
export declare function registerChain(signerProvider: SignerProvider, tokenBridgeId: string, signedVAA: Uint8Array, alphAmount: bigint): Promise<ExecuteScriptResult>;
export declare function deposit(signerProvider: SignerProvider, tokenBridgeForChainId: string, amount: bigint): Promise<ExecuteScriptResult>;
export declare function destroyUnexecutedSequenceContracts(signerProvider: SignerProvider, tokenBridgeId: string, signedVAA: Uint8Array): Promise<ExecuteScriptResult>;
export declare function updateRefundAddress(signerProvider: SignerProvider, tokenBridgeId: string, signedVAA: Uint8Array): Promise<ExecuteScriptResult>;
export declare function zeroPad(value: string, byteLength: number): string;
export declare function getAttestTokenHandlerId(tokenBridgeId: string, remoteChainId: number, groupIndex: number): string;
export declare function getTokenBridgeForChainId(tokenBridgeId: string, remoteChainId: number, groupIndex: number): string;
export declare function getTokenPoolId(tokenBridgeId: string, tokenChainId: number, tokenId: string, groupIndex: number): string;
export declare function getUnexecutedSequenceId(tokenBridgeForChainId: string, index: number, groupIndex: number): string;
export declare function contractExists(contractId: string, provider: NodeProvider): Promise<boolean>;
export interface RemoteTokenInfo extends TokenInfo {
    tokenChainId: ChainId;
}
export declare function getRemoteTokenInfoFromContractState(state: node.ContractState): RemoteTokenInfo;
export declare function getRemoteTokenInfo(address: string): Promise<RemoteTokenInfo>;
export declare function waitAlphTxConfirmed(provider: NodeProvider, txId: string, confirmations: number): Promise<node.Confirmed>;
export declare function getLocalTokenInfo(nodeProvider: NodeProvider, tokenId: string): Promise<TokenInfo>;
