/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Contract, ContractFactory, testMethod, callMethod, multicallMethods, fetchContractState, ContractInstance, } from "@alephium/web3";
import { default as LocalTokenPoolContractJson } from "../token_bridge/LocalTokenPool.ral.json";
import { getContractByCodeHash } from "./contracts";
class Factory extends ContractFactory {
    constructor() {
        super(...arguments);
        this.consts = {
            Path: {
                AttestTokenHandler: "00",
                TokenBridgeForChain: "01",
                TokenPool: "02",
            },
            ErrorCodes: {
                InvalidEmitChainId: BigInt(0),
                InvalidEmitAddress: BigInt(1),
                InvalidMessageSize: BigInt(2),
                InvalidSequence: BigInt(3),
                InvalidModule: BigInt(4),
                InvalidActionId: BigInt(5),
                InvalidVersion: BigInt(6),
                InvalidGuardianSetIndex: BigInt(7),
                InvalidGuardianSetSize: BigInt(8),
                InvalidSignatureSize: BigInt(9),
                InvalidSignatureGuardianIndex: BigInt(10),
                InvalidSignature: BigInt(11),
                GuardianSetExpired: BigInt(12),
                InvalidTargetChainId: BigInt(13),
                ContractStateMismatch: BigInt(14),
                InvalidRegisterChainMessage: BigInt(15),
                InvalidTokenId: BigInt(16),
                InvalidNonceSize: BigInt(17),
                TokenNotExist: BigInt(18),
                InvalidTransferTargetChain: BigInt(19),
                InvalidDestroyUnexecutedSequenceMessage: BigInt(20),
                InvalidCaller: BigInt(21),
                ArbiterFeeLessThanAmount: BigInt(22),
                InvalidAttestTokenMessage: BigInt(23),
                InvalidPayloadId: BigInt(24),
                InvalidTransferMessage: BigInt(25),
                ExpectRemoteToken: BigInt(26),
                InvalidConsistencyLevel: BigInt(27),
                InvalidUpdateRefundAddressMessage: BigInt(28),
                TransferAmountLessThanMessageFee: BigInt(29),
                InvalidAttestTokenArg: BigInt(30),
                InvalidAttestTokenHandler: BigInt(31),
                NotSupported: BigInt(32),
            },
            PayloadId: { Transfer: "01", AttestToken: "02" },
        };
        this.tests = {
            getSymbol: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getSymbol", params);
            }),
            getName: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getName", params);
            }),
            getDecimals: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getDecimals", params);
            }),
            getTotalSupply: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getTotalSupply", params);
            }),
            completeTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "completeTransfer", params);
            }),
            prepareTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "prepareTransfer", params);
            }),
            prepareCompleteTransfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "prepareCompleteTransfer", params);
            }),
            normalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "normalizeAmount", params);
            }),
            deNormalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "deNormalizeAmount", params);
            }),
            transfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "transfer", params);
            }),
        };
    }
    at(address) {
        return new LocalTokenPoolInstance(address);
    }
}
// Use this object to test and deploy the contract
export const LocalTokenPool = new Factory(Contract.fromJson(LocalTokenPoolContractJson, "", "6330d3736eef41d3bc9c5026d0608def44267cc00ed8d8be0620d01f4627f035"));
// Use this class to interact with the blockchain
export class LocalTokenPoolInstance extends ContractInstance {
    constructor(address) {
        super(address);
        this.methods = {
            getSymbol: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "getSymbol", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getName: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "getName", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getDecimals: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "getDecimals", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getTotalSupply: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "getTotalSupply", params === undefined ? {} : params, getContractByCodeHash);
            }),
            normalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "normalizeAmount", params, getContractByCodeHash);
            }),
            deNormalizeAmount: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "deNormalizeAmount", params, getContractByCodeHash);
            }),
            transfer: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(LocalTokenPool, this, "transfer", params, getContractByCodeHash);
            }),
        };
    }
    fetchState() {
        return __awaiter(this, void 0, void 0, function* () {
            return fetchContractState(LocalTokenPool, this);
        });
    }
    multicall(calls) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield multicallMethods(LocalTokenPool, this, calls, getContractByCodeHash));
        });
    }
}
