/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Contract, ContractFactory, testMethod, callMethod, multicallMethods, fetchContractState, ContractInstance, } from "@alephium/web3";
import { default as TokenBridgeFactoryContractJson } from "../token_bridge/TokenBridgeFactory.ral.json";
import { getContractByCodeHash } from "./contracts";
class Factory extends ContractFactory {
    constructor() {
        super(...arguments);
        this.consts = {
            ErrorCodes: {
                InvalidEmitChainId: BigInt(0),
                InvalidEmitAddress: BigInt(1),
                InvalidMessageSize: BigInt(2),
                InvalidSequence: BigInt(3),
                InvalidModule: BigInt(4),
                InvalidActionId: BigInt(5),
                InvalidVersion: BigInt(6),
                InvalidGuardianSetIndex: BigInt(7),
                InvalidGuardianSetSize: BigInt(8),
                InvalidSignatureSize: BigInt(9),
                InvalidSignatureGuardianIndex: BigInt(10),
                InvalidSignature: BigInt(11),
                GuardianSetExpired: BigInt(12),
                InvalidTargetChainId: BigInt(13),
                ContractStateMismatch: BigInt(14),
                InvalidRegisterChainMessage: BigInt(15),
                InvalidTokenId: BigInt(16),
                InvalidNonceSize: BigInt(17),
                TokenNotExist: BigInt(18),
                InvalidTransferTargetChain: BigInt(19),
                InvalidDestroyUnexecutedSequenceMessage: BigInt(20),
                InvalidCaller: BigInt(21),
                ArbiterFeeLessThanAmount: BigInt(22),
                InvalidAttestTokenMessage: BigInt(23),
                InvalidPayloadId: BigInt(24),
                InvalidTransferMessage: BigInt(25),
                ExpectRemoteToken: BigInt(26),
                InvalidConsistencyLevel: BigInt(27),
                InvalidUpdateRefundAddressMessage: BigInt(28),
                TransferAmountLessThanMessageFee: BigInt(29),
                InvalidAttestTokenArg: BigInt(30),
                InvalidAttestTokenHandler: BigInt(31),
                NotSupported: BigInt(32),
            },
        };
        this.tests = {
            getLocalTokenPoolTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getLocalTokenPoolTemplateId", params);
            }),
            getRemoteTokenPoolTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getRemoteTokenPoolTemplateId", params);
            }),
            getTokenBridgeForChainTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getTokenBridgeForChainTemplateId", params);
            }),
            getAttestTokenHandlerTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getAttestTokenHandlerTemplateId", params);
            }),
            getUnexecutedSequenceTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "getUnexecutedSequenceTemplateId", params);
            }),
            parseContractUpgrade: (params) => __awaiter(this, void 0, void 0, function* () {
                return testMethod(this, "parseContractUpgrade", params);
            }),
        };
    }
    at(address) {
        return new TokenBridgeFactoryInstance(address);
    }
}
// Use this object to test and deploy the contract
export const TokenBridgeFactory = new Factory(Contract.fromJson(TokenBridgeFactoryContractJson, "", "b8f3d38c07e360496aaf83fe93eefc04ee4fee57fb5102a628a6c394c67c2e6a"));
// Use this class to interact with the blockchain
export class TokenBridgeFactoryInstance extends ContractInstance {
    constructor(address) {
        super(address);
        this.methods = {
            getLocalTokenPoolTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "getLocalTokenPoolTemplateId", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getRemoteTokenPoolTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "getRemoteTokenPoolTemplateId", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getTokenBridgeForChainTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "getTokenBridgeForChainTemplateId", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getAttestTokenHandlerTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "getAttestTokenHandlerTemplateId", params === undefined ? {} : params, getContractByCodeHash);
            }),
            getUnexecutedSequenceTemplateId: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "getUnexecutedSequenceTemplateId", params === undefined ? {} : params, getContractByCodeHash);
            }),
            parseContractUpgrade: (params) => __awaiter(this, void 0, void 0, function* () {
                return callMethod(TokenBridgeFactory, this, "parseContractUpgrade", params, getContractByCodeHash);
            }),
        };
    }
    fetchState() {
        return __awaiter(this, void 0, void 0, function* () {
            return fetchContractState(TokenBridgeFactory, this);
        });
    }
    multicall(calls) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield multicallMethods(TokenBridgeFactory, this, calls, getContractByCodeHash));
        });
    }
}
