import { Address, ContractState, TestContractResult, HexString, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace TokenBridgeV1Types {
    type Fields = {
        governanceContractId: HexString;
        localChainId: bigint;
        receivedSequence: bigint;
        sendSequence: bigint;
        tokenBridgeFactory: HexString;
        minimalConsistencyLevel: bigint;
        refundAddress: Address;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<TokenBridgeV1Instance, TokenBridgeV1Types.Fields> {
    at(address: string): TokenBridgeV1Instance;
    tests: {
        foo: (params: Omit<TestContractParams<TokenBridgeV1Types.Fields, never>, "testArgs">) => Promise<TestContractResult<null>>;
    };
}
export declare const TokenBridgeV1: Factory;
export declare class TokenBridgeV1Instance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<TokenBridgeV1Types.State>;
}
export {};
