import { Address, ContractState, TestContractResult, HexString, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace UnexecutedSequenceTypes {
    type Fields = {
        parentId: HexString;
        begin: bigint;
        sequences: bigint;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<UnexecutedSequenceInstance, UnexecutedSequenceTypes.Fields> {
    consts: {
        ErrorCodes: {
            InvalidEmitChainId: bigint;
            InvalidEmitAddress: bigint;
            InvalidMessageSize: bigint;
            InvalidSequence: bigint;
            InvalidModule: bigint;
            InvalidActionId: bigint;
            InvalidVersion: bigint;
            InvalidGuardianSetIndex: bigint;
            InvalidGuardianSetSize: bigint;
            InvalidSignatureSize: bigint;
            InvalidSignatureGuardianIndex: bigint;
            InvalidSignature: bigint;
            GuardianSetExpired: bigint;
            InvalidTargetChainId: bigint;
            ContractStateMismatch: bigint;
            InvalidRegisterChainMessage: bigint;
            InvalidTokenId: bigint;
            InvalidNonceSize: bigint;
            TokenNotExist: bigint;
            InvalidTransferTargetChain: bigint;
            InvalidDestroyUnexecutedSequenceMessage: bigint;
            InvalidCaller: bigint;
            ArbiterFeeLessThanAmount: bigint;
            InvalidAttestTokenMessage: bigint;
            InvalidPayloadId: bigint;
            InvalidTransferMessage: bigint;
            ExpectRemoteToken: bigint;
            InvalidConsistencyLevel: bigint;
            InvalidUpdateRefundAddressMessage: bigint;
            TransferAmountLessThanMessageFee: bigint;
            InvalidAttestTokenArg: bigint;
            InvalidAttestTokenHandler: bigint;
            NotSupported: bigint;
        };
    };
    at(address: string): UnexecutedSequenceInstance;
    tests: {
        checkSequence: (params: TestContractParams<UnexecutedSequenceTypes.Fields, {
            seq: bigint;
            refundAddress: Address;
        }>) => Promise<TestContractResult<null>>;
        destroy: (params: TestContractParams<UnexecutedSequenceTypes.Fields, {
            refundAddress: Address;
        }>) => Promise<TestContractResult<null>>;
    };
}
export declare const UnexecutedSequence: Factory;
export declare class UnexecutedSequenceInstance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<UnexecutedSequenceTypes.State>;
}
export {};
