import { Address, ContractState, TestContractResult, HexString, ContractFactory, TestContractParams, ContractInstance } from "@alephium/web3";
export declare namespace UnexecutedSequenceTestTypes {
    type Fields = {
        unexecutedSequenceId: HexString;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<UnexecutedSequenceTestInstance, UnexecutedSequenceTestTypes.Fields> {
    at(address: string): UnexecutedSequenceTestInstance;
    tests: {
        checkSequence: (params: TestContractParams<UnexecutedSequenceTestTypes.Fields, {
            seq: bigint;
        }>) => Promise<TestContractResult<null>>;
        destroy: (params: Omit<TestContractParams<UnexecutedSequenceTestTypes.Fields, never>, "testArgs">) => Promise<TestContractResult<null>>;
    };
}
export declare const UnexecutedSequenceTest: Factory;
export declare class UnexecutedSequenceTestInstance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<UnexecutedSequenceTestTypes.State>;
}
export {};
